// BPSK400.cpp : Defines the initialization routines for the DLL.
//
//////////////////////////////////////////////////////////////////////
// Copyright 2000.    Moe Wheatley AE4JY  <ae4jy@qsl.net>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "BPSK400.h"
#include "iocntrl.h"
#include "BPSK400externals.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CBPSK400App

BEGIN_MESSAGE_MAP(CBPSK400App, CWinApp)
	//{{AFX_MSG_MAP(CBPSK400App)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBPSK400App construction

CBPSK400App::CBPSK400App()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


CIOCntrl* pCIOCntrl = NULL;
/////////////////////////////////////////////////////////////////
// Control functions
/////////////////////////////////////////////////////////////////
long COREDLL_API __stdcall fnStartSoundReceive(HWND h_Wnd, long cardnum,
													long EchoWave, long UseAFC )
{
long error = 0;
	if(pCIOCntrl)
	{
		pCIOCntrl->m_CardNum = cardnum;
		error =  pCIOCntrl->StartIO(h_Wnd, FALSE,EchoWave,UseAFC);
	}
	return error;
}

long COREDLL_API __stdcall fnStartWaveReceive(HWND h_Wnd, const char* sPath,
													long UseAFC, long Offset)
{
long error = 0;
long FileSize;
	if(pCIOCntrl)
	{
		if( error = pCIOCntrl->SetInFilePath(sPath, &FileSize, Offset) )
			return error;
		error =  pCIOCntrl->StartIO(h_Wnd, TRUE, FALSE, UseAFC);
	}
	return error;
}

void COREDLL_API __stdcall fnStopReceive(void)
{
	if(pCIOCntrl)
		pCIOCntrl->StopIO();
}

void COREDLL_API __stdcall fnSetRxMode(long UseAFC)
{
	if(pCIOCntrl)
		pCIOCntrl->m_UseAFC = UseAFC;
}

long COREDLL_API __stdcall fnCheckWavePath( const char* sPath, long* pFileSize)
{
long error = 0;
	if(pCIOCntrl)
	{
		error = pCIOCntrl->SetInFilePath(sPath, pFileSize, -1);
	}
	return error;
}

long COREDLL_API __stdcall fnSetOutWavePath( const char* sPath, long AppendMode)
{
long error = 0;
	if(pCIOCntrl)
	{
		error = pCIOCntrl->SetOutWavePath(sPath, AppendMode);
	}
	return error;
}

void COREDLL_API __stdcall fnPauseOutWave( long state)
{
	if(pCIOCntrl)
	{
		pCIOCntrl->m_WaveOutPaused = state;
	}
}

void COREDLL_API __stdcall fnSetRigCtrlOptions( long port, long mode,
											   long centerfreq,long usb,
											   long params, INT stepsz)
{
	if(pCIOCntrl)
	{
		pCIOCntrl->m_RigCntrl.SetRigCtrlOptions( port, mode, centerfreq,usb,params, stepsz);
	}
}

long COREDLL_API __stdcall fnSetManualRate( long rate)
{
long x = 0;
	if(pCIOCntrl)
	{
		x = pCIOCntrl->m_RigCntrl.SetManualRate( rate);
	}
	return x;
}

long COREDLL_API __stdcall fnGetDopCorrectionRate( )
{
long x = 0;
	if(pCIOCntrl)
	{
		x = pCIOCntrl->m_RigCntrl.GetDopCorrectionRate();
	}
	return x;
}

long COREDLL_API __stdcall fnCheckComPort( long port)
{
long ok = 0;
	if(pCIOCntrl)
	{
		ok = pCIOCntrl->m_RigCntrl.CheckComPort(port);
	}
	return ok;
}

void COREDLL_API __stdcall fnSetCmdStrings(const char* sUp, const char* sDn )
{
	if(pCIOCntrl)
	{
		pCIOCntrl->m_RigCntrl.SetCmdStrings( sUp, sDn);
	}
}

/////////////////////////////////////////////////////////////////
// RX Functions
/////////////////////////////////////////////////////////////////
void COREDLL_API __stdcall fnSetRXFrequency(long freq)
{
	if(freq>3400)
		freq = 3400;
	if(freq<200)
		freq = 200;
	if(pCIOCntrl)
	{
		pCIOCntrl->ResetRigCtrl();
		pCIOCntrl->m_pBpskdet->SetRXFrequency( freq );
	}
}

void COREDLL_API __stdcall fnSetBitAdj( long adj)
{
	if(adj>150)
		adj = 150;
	if(adj<-150)
		adj = -150;
	if(pCIOCntrl)
	{
		pCIOCntrl->ResetRigCtrl();
		pCIOCntrl->m_pBpskdet->SetBitAdj( adj);
	}
}

void COREDLL_API __stdcall fnGetRXFrequency(long* pfreq, double* pdopplerate)
{
	if(pCIOCntrl)
		 pCIOCntrl->m_pBpskdet->GetRXFrequency((INT*)pfreq, pdopplerate);
}


void COREDLL_API __stdcall fnGetVectorData(long* vectorarray)
{
	if(pCIOCntrl)
	{
		pCIOCntrl->m_pBpskdet->GetVectorData(vectorarray);
	}
}

void COREDLL_API __stdcall fnSetFFTParams(LONG ave, double gain, LONG type)
{
	if(pCIOCntrl)
		pCIOCntrl->SetFFTParams( ave, gain, type );
}

long COREDLL_API __stdcall fnGetFFTData(long* array, long start, long end )
{
long result = 0;
	if(start>1022)
		start = 1022;
	if(start<0)
		start = 0;
	if(end>1023)
		end = 1023;
	if(end<1)
		end = 1;
	if(pCIOCntrl)
	{
		result = pCIOCntrl->GetFFTData(array, start, end);
	}
	return result;
}


long COREDLL_API __stdcall fnGetDataBlock(char* pData)
{
long result = FALSE;
	if(pCIOCntrl)
	{
		result = pCIOCntrl->m_pBpskdet->GetDataBlock(pData);
	}
	return result;
}

/////////////////////////////////////////////////////////////////
//  MISC Functions
/////////////////////////////////////////////////////////////////
void COREDLL_API __stdcall fnGetErrorString(char* lpszError)
{
CString err = "";
	if(pCIOCntrl)
		pCIOCntrl->GetErrorMsg(err);
	strcpy( lpszError, (LPCTSTR)err);
}

long COREDLL_API __stdcall fnGetDLLVersion ()
{	
long version = 0;
	if(pCIOCntrl)
		version = pCIOCntrl->m_DLLRevision;
	return version;
}

long COREDLL_API __stdcall fnGetDebugData(double* val1, double* val2)
{
	*val1 = DebugFP1;
	*val2 = DebugFP2;
	return DebugINT;
}

long COREDLL_API __stdcall fnGetBitPosition()
{
	if(pCIOCntrl && pCIOCntrl->m_pBpskdet)
			return pCIOCntrl->m_pBpskdet->GetBitPosition();
	else
		return 0;
}

double COREDLL_API __stdcall fnZeroSNR(double filterfactor)
{
	if(pCIOCntrl && pCIOCntrl->m_pBpskdet)
			return pCIOCntrl->m_pBpskdet->ZeroSNR(filterfactor);
	else
		return 0.0;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CBPSK400App object

CBPSK400App theApp;

BOOL CBPSK400App::InitInstance() 
{
BOOL ret=TRUE;
	pCIOCntrl = new CIOCntrl();
	if(pCIOCntrl)
		ret = pCIOCntrl->InitSystem();
	return (ret && CWinApp::InitInstance() );
}

int CBPSK400App::ExitInstance() 
{
	if(pCIOCntrl)
	{
		pCIOCntrl->StopIO();
		delete pCIOCntrl;
		pCIOCntrl = NULL;
	}
	return CWinApp::ExitInstance();
}
