// RigCntrl.h: interface for the CRigCntrl class.
//
//////////////////////////////////////////////////////////////////////
// Copyright 2000.    Moe Wheatley AE4JY  <ae4jy@qsl.net>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////
//

#if !defined(AFX_CRigCntrl_H__ED8BF853_5C8C_11D3_A248_00A0C996E7F5__INCLUDED_)
#define AFX_CRigCntrl_H__ED8BF853_5C8C_11D3_A248_00A0C996E7F5__INCLUDED_



#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"
#include "BPSKDet.h"

class CRigCntrl  
{
public:
	void SetCmdStrings(CString sUp,CString sDn);
	void ResetCtrl(CBPSKDet* pDet);
	INT SetManualRate(INT rate);
	void CalculateFrequencyControl(INT freq, double doppler, INT detstatus);
	void SetRigCtrlOptions(INT port, INT mode, INT centerfreq,BOOL usb, INT params, INT stepsz);
	BOOL CheckComPort(LONG port);
	INT GetDopCorrectionRate(){	if(m_USB) return -m_PulseRate;else return m_PulseRate;};
//Methods
	void Stop();
	void ProcessLoop();
	INT Start();
	CRigCntrl();
	virtual ~CRigCntrl();
//Publicly exposed Variables

private:
	INT m_AdjStepSize;
	BOOL m_BurstCorrectionActive;
	INT m_BurstCorrectionCount;
	INT m_StepSize;
	INT m_DopplerTimeOut;
	INT FormatString( CString inStr, CHAR* pOut );
	void WriteCMDString( const char *str, INT length);
	void ProcessCMDLoop();
	void ProcessRTSDTRLoop();
	void OpenComPort();
	void CloseComPort();
	BOOL m_CMDMode;
	void CalcPulseTime(INT rate);
	void RTSDTRCntrl(INT state);
	INT m_FrequencySetPoint;
	double m_CFerror;
	double m_IntegratorSum;
	double m_LastDoppler;
	INT m_OffTime;
	INT m_Mode;
	BOOL m_USB;
	INT m_ComState;
	INT m_ComPort;
	HANDLE m_hComPort;
	DWORD m_BitRate;
	BYTE m_Parity;
	BYTE m_NumBits;
	INT m_PulseRate;
	LONGLONG m_StartTime;
	LONGLONG m_StopTime;
	LONGLONG m_CountFreq;
	INT m_UPCmdLen;
	INT m_DNCmdLen;
	CHAR m_sUp[50];
	CHAR m_sDn[50];

//Functions
	void DeleteResources();
	void StopThread( );

//Variables
	BOOL m_fProcThreadQuit;			// signal to thread to quit
	BOOL m_ThreadActive;
	CWinThread* m_pProcThread;
	CBPSKDet* m_pBpskdet;
	CRITICAL_SECTION m_CriticalSection;	//for keeping threads from stomping on each other

};

#endif // !defined(AFX_RIGCNTRL_H__ED8BF853_5C8C_11D3_A248_00A0C996E7F5__INCLUDED_)
