// RcvEditCtrl.cpp : implementation file
//
//////////////////////////////////////////////////////////////////////
// Copyright 2000.    Moe Wheatley AE4JY  <ae4jy@qsl.net>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ao40rcv.h"
#include "ao40rcvdoc.h"
#include "ao40rcvview.h"
#include "RcvEditCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CRcvEditCtrl

CRcvEditCtrl::CRcvEditCtrl()
{
}

CRcvEditCtrl::~CRcvEditCtrl()
{
}


BEGIN_MESSAGE_MAP(CRcvEditCtrl, CRichEditCtrl)
	//{{AFX_MSG_MAP(CRcvEditCtrl)
	ON_WM_CREATE()
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_CONTROL_REFLECT(EN_KILLFOCUS, OnKillfocus)
	ON_WM_VSCROLL()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRcvEditCtrl message handlers
int CRcvEditCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CRichEditCtrl::OnCreate(lpCreateStruct) == -1)
		return -1;
	return 0;
}

// Initializes the Font, font color, and background color for the
//  edit box
void CRcvEditCtrl::SetCharFormat(LOGFONT lf, COLORREF crText, 
							COLORREF crBackground )
{
	GetDefaultCharFormat(m_InsertFormat);
	m_InsertFormat.cbSize=sizeof(CHARFORMAT);
	m_InsertFormat.dwMask = CFM_BOLD|CFM_ITALIC|CFM_UNDERLINE|CFM_STRIKEOUT|
								CFM_CHARSET|CFM_COLOR|CFM_FACE|CFM_SIZE;
	m_InsertFormat.crTextColor = crText;
	m_InsertFormat.yHeight = -lf.lfHeight*20;
	m_InsertFormat.bCharSet = lf.lfCharSet;
	m_InsertFormat.dwEffects = 0;
	if(lf.lfItalic)
		m_InsertFormat.dwEffects |= CFE_ITALIC;
	if(lf.lfUnderline)
		m_InsertFormat.dwEffects |= CFE_UNDERLINE;
	if(lf.lfStrikeOut)
		m_InsertFormat.dwEffects |= CFE_STRIKEOUT;
	if(lf.lfWeight > 500)
		m_InsertFormat.dwEffects |= CFE_BOLD;

	m_InsertFormat.bPitchAndFamily = lf.lfPitchAndFamily;
	strcpy( m_InsertFormat.szFaceName, lf.lfFaceName );
//
	SetBackgroundColor( FALSE, crBackground );
	SetDefaultCharFormat(m_InsertFormat);
	SetSelectionCharFormat(m_InsertFormat);
	ClearAll();
}

///////////////////////////////////////////////////////////////////////////////
//  Set text in this edit box
///////////////////////////////////////////////////////////////////////////////
void CRcvEditCtrl::SetText(CString str)
{
	SetSel(0,-1);
	ReplaceSel( str );
	LineScroll( m_FirstVisableLine,  0 );
}

///////////////////////////////////////////////////////////////////////////////
//  Clear the whole edit box
///////////////////////////////////////////////////////////////////////////////
void CRcvEditCtrl::ClearAll()
{
char temp[2]={0,0};
	m_FirstVisableLine = GetFirstVisibleLine();
	SetSel(0,-1);
	ReplaceSel( (CHAR*)temp );
}

///////////////////////////////////////////////////////////////////////////////
//  Cancels any text selection
///////////////////////////////////////////////////////////////////////////////
void CRcvEditCtrl::CancelSelection()
{
INT TotalLength = GetTextLength();
	if( (TotalLength>1) )
		SetSel(TotalLength,TotalLength);
}

///////////////////////////////////////////////////////////////////////////////
//  Clipboard functions
///////////////////////////////////////////////////////////////////////////////
void CRcvEditCtrl::OnEditCopy() 
{
	CopyClip();
}

void CRcvEditCtrl::CopyClip()
{
	Copy();
}

BOOL CRcvEditCtrl::OKCopy()
{
CHARRANGE cr;	
	GetSel(cr);
	return( cr.cpMax>cr.cpMin);
}

void CRcvEditCtrl::OnKillfocus() 
{
}


void CRcvEditCtrl::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	
	CRichEditCtrl::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CRcvEditCtrl::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
//	CRichEditCtrl::OnLButtonDown(nFlags, point);
}
